# TMS接口常见问题

----

- [通过创建订单接口创建的订单登陆系统以后没有查看到](#通过创建订单接口创建的订单登陆系统以后没有查看到)
- [更新受理单接口中的组织机构](#更新受理单接口中的组织机构)
- [车次订阅接口与订单订阅接口](#车次订阅接口与订单订阅接口)


## 通过创建订单接口创建的订单登陆系统以后没有查看到

<p>&emsp;&emsp;通过<a href="README.md#创建订单接口">创建订单接口</a>创建的订单登陆系统以后没有查看到创建订单接口必须使用主账号获取token以后再用主账号调用才能看到，
如果是用的子账号调用接口，将无法查看到相应的信息。正常调用成功以后只能通过主账号查看订单信息，如果希望子账号也能查看到订单信息，在使用主账号调用接口的时候需要传递一个
【organizationPath (string): 组织机构：可不填】参数，指定你希望哪个子账号对应的组织机构可以看到。
<p>&emsp;&emsp;对应的组织机构需要调用<a href="README.md#获取组织机构列表接口">获取组织机构列表接口</a>，调用成功后返回的【path】参数即对应组织机构的参数值，
根据返回结果，把organizationPath的值设置为path中的值，比如0-11，这样，对应的组织机构就可以看到。
<p>&emsp;&emsp;注意，直接用子账号调用创建订单接口是无法看到订单信息的！


## 更新受理单接口中的组织机构

<p>&emsp;&emsp;更新受理单中的CustomerOrderEntity中有个可选参数：organizationPath，当用到组织机构时需要传递此参数，调用接口时传递的参数值为获取组织机构列表接口中的path的值
（即organizationPath=path），path的值不会因为修改组织机构名字而改变，所以需要先调用<a href="README.md#获取组织机构列表接口">获取组织机构列表接口</a>获取path(或者使用浏览器的开发者工具在系统中查看)。
组织机构名字（name）是在【公司管理-组织机构管理】中手动设置的。

<div align="center">
<img src="image/组织机构返回参数.png" width = "200" height = "350" alt="组织机构返回参数"/><br/>
<img src="image/开发者工具获取组织机构path.png" width = "800" height = "450" alt="开发者工具获取组织机构path"/>
</div>

## 车次订阅接口与订单订阅接口

<p>&emsp;&emsp;<b>相同点</b>：两者均为调用成功后即开始推送，无需指定车次号(订单号)，当某一个车次(订单)状态变化时便会返回报文。
<p>&emsp;&emsp;<b>不同点</b>：一个车次中可以包含多个订单，两者的状态是不同的，车次状态的改变未必会导致订单状态改变，只有当车次状态变化时才会回调车次报文，订单接口同理。所以需要根据需求决定使用哪一个接口，或者两个结合使用。
<p>&emsp;&emsp;以下为两者状态的详细信息

<div align="center">
<img src="image/车次订阅接口状态.png" width = "700" height = "300" alt="车次订阅接口状态"/>
</div>

<div align="center">
<img src="image/订单订阅接口状态.png" width = "700" height = "300" alt="订单订阅接口状态"/>
</div>